/*--------------------------------------------------------------------------*/
/*		httpc.c																*/
/*			ȈHTTPNCAg											*/
/*		(C) Copyright 1997 By Tomoaki Nakashima. All right reserved.		*/
/*--------------------------------------------------------------------------*/

#include <stdio.h>
#include <string.h>
#include <winsock.h>

#define BUFSIZE		256		/* obt@TCY */
#define RECVSIZE	4096	/* Mobt@TCY */

int main(int argc,char **argv)
{

	WORD wVersionRequested;
	int  nErrorStatus;
	WSADATA wsaData;
	char svName[BUFSIZE];						/* T[õhC */
	char html[BUFSIZE];							/* 擾y[W̃pX */
	unsigned short port = 80;					/* |[gԍ */
	int soc;									/* \PbgiSoket Descriptorj */
	unsigned long serveraddr;					/* T[oIPAhX */
	struct hostent *serverhostent;				/* T[ȍw|C^ */
	struct  sockaddr_in     serversockaddr;		/* T[õAhX */
	char sendbuf[BUFSIZE];						/* Mobt@ */
	char recvbuf[RECVSIZE];						/* Mobt@ */
	int buf_len;								/* MoCg */
	char *p,*r,*t,wk[8];						/* Ɨp̈ */
	int i;

	/*----------------------------------------------------------*/
	/*		URLT[oƃy[W̃pX擾		*/
	/*----------------------------------------------------------*/

	/*  1ł͂ȂꍇA̕7ȉ̏ꍇ́A̐\ */
	if(argc != 2 || strlen(argv[1]) <= 7){
		fprintf(stderr,"httpc URL\n");
		return -1;
	}

	/* XL[擾 */
	for(i = 0;i < 7;i++){
		wk[i] = argv[1][i];
	}
	wk[i] = '\0';
	if(strcmpi(wk,"http://") != 0){
		fprintf(stderr,"Error: httpURLł͂܂\n");
		return -1;
	}

	/* T[o擾 */
	for(p = argv[1] + i,r = svName;*p != '/' && *p != '\0';p++,r++){
		*r = *p;
	}
	*r = '\0';

	/* 擾y[W̃pX擾 */
	for(r = html;*p != '\0';p++,r++){
		*r = *p;
	}
	*r = '\0';

	/* T[o:|[g ƂȂĂꍇ͕ */
	for(p = svName;*p != ':' && *p != '\0';p++);
	if(*p == ':'){
		for(t = p + 1,r = wk;*t != '\0';t++,r++){
			*r = *t;
		}
		*r = '\0';
		port = (unsigned short)atoi(wk);

		*p = '\0';
	}

	/* y[W̎w肪ꍇ́A/ ([g)ݒ肷 */
	if(strcmp(html,"") == 0){
		strcpy(html,"/");
	}

	/*----------------------------------------------------------*/
	/*			w̃T[ow̃y[W擾			*/
	/*----------------------------------------------------------*/

	/* WinSock̏s */
	wVersionRequested = MAKEWORD(1,1);						/* o[W 1.1 v */
	nErrorStatus = WSAStartup(wVersionRequested, &wsaData);
	if(atexit((void (*)(void))(WSACleanup))){				/* IWinSock̃\[X悤ɂĂ */
		fprintf(stderr,"Error: atexit(WSACleanup)s\n");
		return -1;
	}
	if(nErrorStatus != 0){
		fprintf(stderr,"Error: WinSock̏s\n");
		return -1;
	}

	/* socɃ\Pbg쐬܂ */
	soc = socket(PF_INET,SOCK_STREAM,0);
	if(soc == INVALID_SOCKET){
		fprintf(stderr,"Error: Socket쐬s\n");
		return -1;
	}

	/* svNameɃhbgŋ؂10iIPAhXĂꍇAserveraddr32bitIPAhXԂ܂ */
	serveraddr = inet_addr((char*)svName);
	if(serveraddr == -1) {
		/* T[o(svName)T[ȍ擾܂ */
		serverhostent = gethostbyname(svName);
		if(serverhostent == NULL) {
			fprintf(stderr,"Error: zXgAhX擾s\n");
			/* \Pbgj */
			closesocket(soc);
			return -1;
		}else{
			/* T[ȍ񂩂IPAhXserveraddrɃRs[܂ */
			serveraddr = *((unsigned long *)((serverhostent->h_addr_list)[0]));
		}
	}

	/* T[õAhX̍\̂ɃT[oIPAhXƃ|[gԍݒ肵܂ */
	serversockaddr.sin_family       = AF_INET;							/* C^[lbg̏ꍇ */
	serversockaddr.sin_addr.s_addr  = serveraddr;						/* T[oIPAhX */
	serversockaddr.sin_port         = htons((unsigned short)port);		/* |[gԍ */
	memset(serversockaddr.sin_zero,(int)0,sizeof(serversockaddr.sin_zero));
	/* T[o֐ڑ܂ */
	if(connect(soc,(struct sockaddr *)&serversockaddr,sizeof(serversockaddr)) == SOCKET_ERROR){
		fprintf(stderr,"Error: T[oւ̐ڑs\n");
		/* \Pbgj */
		closesocket(soc);
		return -1;
	}

	/* T[o GET NGXg𑗐M܂ */
	/* M̓T[oɓ͂܂ */
	sprintf(sendbuf,"GET %s HTTP/1.0\r\nHost: %s:%d\r\nUser-Agent: httpc/0.0\r\n\r\n",html,svName,port);	/* NGXgwb_쐬 */
	if(send(soc,sendbuf,strlen(sendbuf),0) == SOCKET_ERROR){
		fprintf(stderr,"Error: T[oւ̑Ms\n");
		/* M𖳌ɂ */
		shutdown(soc,2);
		/* \Pbgj */
		closesocket(soc);
		return -1;
	}

	/* T[of[^ׂĎMI܂ŌJԂ */
	while(1){
		/* T[of[^M܂ */
		buf_len = recv(soc,recvbuf,RECVSIZE - 1,0);
		if(buf_len == SOCKET_ERROR){	/* Ms̏ꍇ */
			fprintf(stderr,"Error: T[o̎Ms\n");
			break;
		}else if(buf_len == 0){			/* MI */
			break;
		}
		recvbuf[buf_len] = '\0';	/* Mobt@̌NULLt */
		printf("%s",recvbuf);		/* Wo͂ */
	}

	/* M𖳌ɂ */
	shutdown(soc,2);
	/* \Pbgj */
	closesocket(soc);

	return 0;
}
